#include <Inspc/DataStruct_Inspc.h>
#include <Inspc/DataNode_Inspc.h>
#include <Inspc/Out_DataStruct_Inspc.h>
#include <emC/DefPortTypes_emC.h>
#include <emC/Handle_ptr64_emC.h> //Support 64-bit-pointer

#include <Inspc/CheckPwd_Inspc.h>
#include <Jc/FileIoJc.h>
#include <Jc/StringJc.h>
#include <J1c/StringFunctionsJc.h>
#include <OSAL/os_mem.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "genRefl/Inspc/DataStruct_Inspc.crefl"

//NOTE: This source is only compiled for PC inside the Sfunction. 
//The target does not need this sources, instead the generated source from this Sfunction. 
//See operation




char const* genSource_DataStructMng_Inspc(DataStructMng_Inspc* thiz, StringJc dirGenSrc)
{ char const* error = null;
  FileDescription_OSAL dir = { 0 };
  int zDirFile = 0;
  char const* sDirFile = getCharsAndLength_StringJc(&dirGenSrc, &zDirFile);
  if(zDirFile == 0) { 
    thiz->stateGen = 1; return "no file"; //no file path given.
  }
  init_FileDescription_OSAL(&dir, 0, sDirFile, zDirFile);
  refresh_FileDescription_OSAL(&dir);
  if(!exists_FileDescription_OSAL(&dir)) { thiz->stateGen = 0xd; error = "directory faulty"; }
  else { //directory exists
    int zName = strnlen_emC(thiz->clazz.name, sizeof(thiz->clazz.name));
    char buffer[40]; 
    int zpos = strncpy_emC(buffer, thiz->clazz.name, sizeof(thiz->clazz.name));
    zpos += strcpy_emC(buffer + zpos, ".h", sizeof(buffer)-zpos);
    initDir_FileDescription_OSAL(&thiz->filegen, 0, &dir, buffer, zpos);
  }
  return error;
}


void ctor_DataStructMng_Inspc(DataStructMng_Inspc* thiz)
{
  STACKTRC_ENTRY("ctor_DataStruct_Inspc");
  initReflection_ObjectJc(&thiz->base.object, thiz, sizeof(*thiz), &reflection_DataStructMng_Inspc, 0);  
  STACKTRC_RETURN;
}

void dtor_DataStructMng_Inspc(DataStructMng_Inspc* thiz) {
  for (int ix = 0; ix < thiz->fields->head.length; ++ix) {  //Note: The last field is not dynamicall typed.
    FieldJc* field = &thiz->fields->data[ix];
    if (((intptr_t)field->type_) > kREFLECTION_afterlastPrimitive_ClassJc) { //it is a allocated ClassJc
      os_freeMem(field->type_);
    }
  }
  os_freeMem(thiz->fields);
  os_freeMem(thiz->userData);
}


void ctor_DataStruct_Inspc(DataStruct_Inspc* thiz
  , StringJc n1_param, StringJc n2_param, StringJc n3_param, StringJc n4_param, StringJc n5_param, StringJc n6_param
)
{
  STACKTRC_ENTRY("ctor_DataStruct_Inspc");
  initReflection_ObjectJc(&thiz->base.object, thiz, sizeof(*thiz), &reflection_DataStruct_Inspc, 0);
  thiz->names[0] = n1_param;
  thiz->names[1] = n2_param;
  thiz->names[2] = n3_param;
  thiz->names[3] = n4_param;
  thiz->names[4] = n5_param;
  thiz->names[5] = n6_param;
  //make persistent:
  int zBuffer = 1;  //1 reserve for ending 0 for debug of bufferNames. The char for StringJc do not need 0-termination.
  for (int ix = 0; ix < 6; ++ix) {
    zBuffer += length_StringJc(thiz->names[ix]);
  }

  char* pBuffer = (char*)os_allocMem(zBuffer);
  thiz->bufferNames = ret_MemC(pBuffer, zBuffer);

  for (int ix = 0; ix < 6 /*ARRAYLEN_emC(thiz->names)*/; ++ix) {
    int nChars = copyToBuffer_StringJc(thiz->names[ix], 0, -1, pBuffer, zBuffer);
    thiz->names[ix] = zI_StringJc(pBuffer, nChars);  //replace with persistent string.
    pBuffer += nChars;
    zBuffer -= nChars;
  }
  STACKTRC_RETURN;
}



void dtor_DataStruct_Inspc(DataStruct_Inspc* thiz) {
  char* pBufferNames = PTR_MemC(thiz->bufferNames, char);
  if (pBufferNames) {
    os_freeMem(pBufferNames);
  }
}





/**Returns nrofValues in bit 31..16 and nrofFields in bits 7..0.
*/
static int32 evalSizes_DataStructBase_Inspc(DataStruct_Inspc* thiz)
{
  int ixVal = 0;
  int nrofFields = 0;
  int nrofValues = 0;
  for (int ixArg = 0; ixArg < 6; ++ixArg) {
    thiz->ixInVal[ixArg] = ixVal;
    int zname; char const* name = getCharsAndLength_StringJc(&thiz->names[ixArg], &zname);
    if (zname > 0) {
      int nrofBytesType = 0;
      if (name[0] == '-') { //access rights
        name += 2; zname -= 2;
        char cAccess = name[0];  //next char: write
        if (cAccess >= '0' && cAccess <= '7') {
          name += 1; zname -= 1;
        }
        if (*name == ':') { name += 1; zname -= 1; } //skip over ':', "-27:" admissible.
      }
      while (zname >0 && *name == ' ') { name += 1; zname -= 1; } //skip spaces
      int posPtr = searchChar_emC(name, zname, '*');
      if (posPtr >= 0) {  //access to the content of a pointer.
        if (thiz->portTypes->entries[ixArg].type == 'U') {
          nrofBytesType = 4;
          if (posPtr > 0) {
            thiz->dataTypeSmlkInput[ixArg] = 'H'; //typed Handle
          }
          else {
            thiz->dataTypeSmlkInput[ixArg] = 'L'; //An Object
          }
        }
        else { //any other type then uint32
          thiz->dataTypeSmlkInput[ixArg] = 'P'; //Pointer
        }
        name += posPtr + 1;  //without '*'
        zname -= posPtr + 1;
      }
      if (thiz->dataTypeSmlkInput[ixArg] == 0) {
        //define the type , it is defined for special cases already.
        bool bComplex = thiz->portTypes->entries[ixArg].type >= 'a';
        int cType;
        thiz->dataTypeSmlkInput[ixArg] = thiz->portTypes->entries[ixArg].type;
        switch (thiz->portTypes->entries[ixArg].type) {
        case 'D': nrofBytesType = 8; cType = kREFLECTION_double_ClassJc; break;
        case 'd': nrofBytesType = 8; cType = kREFLECTION_complexdouble_ClassJc; break;
        case 'F': nrofBytesType = 4; cType = kREFLECTION_float_ClassJc; break;
        case 'f': nrofBytesType = 4; cType = kREFLECTION_complexfloat_ClassJc; break;
        case 'I': nrofBytesType = 4; cType = kREFLECTION_int32_ClassJc; break;
        case 'i': nrofBytesType = 4; cType = kREFLECTION_int32_ClassJc; break;
        case 'U': nrofBytesType = 4; cType = kREFLECTION_uint32_ClassJc; break;
        case 'S': nrofBytesType = 2; cType = kREFLECTION_int16_ClassJc; break;
        case 'W': nrofBytesType = 2; cType = kREFLECTION_uint16_ClassJc; break;
        case 'B': nrofBytesType = 1; cType = kREFLECTION_int8_ClassJc; break;
        case 'V': nrofBytesType = 1; cType = kREFLECTION_uint8_ClassJc; break;
        case 'C': nrofBytesType = 1; cType = kREFLECTION_char_ClassJc; break;
        case 'Z': nrofBytesType = 1; cType = kREFLECTION_boolean_ClassJc; break;
          //Bus: type = 0x20
        default: cType = REFLECTION_uint32_ClassJc;
        } //switch
        if (bComplex) { nrofBytesType *= 2; }
      }
      int sizeArray = thiz->portTypes->entries[ixArg].sizeArray[0]; //0 possible if scalar. 
      if (sizeArray > 1) {                           //==1: remain 0 for scalar.
        nrofBytesType *= sizeArray;
      }
      int ixValNext = ixVal + ((nrofBytesType + 3) >> 2); //aligned to 4
      ixVal = ixValNext;
      thiz->nrofbytesInput[ixArg] = nrofBytesType;
      nrofFields += 1;
      nrofValues += (nrofBytesType + 3) >> 2;
    } //zname >0
  }
  return (nrofValues << 16) + nrofFields;
}




static int evalNames_DataStructBase_Inspc(DataStruct_Inspc* thiz, DataStructMng_Inspc* master, int ixField)
{
  int ixData = master->ixDataLast;
  for (int ixArg = 0; ixArg < 6; ++ixArg) {
    thiz->ixInVal[ixArg] = ixData;
    int zname; char const* name = getCharsAndLength_StringJc(&thiz->names[ixArg], &zname);
    //Note: name may not be 0-terminated because it comes from a StringJc which is not 0-terminated in any case. Regard zname.
    if (zname > 0) {
      FieldJc* field = &master->fields->data[ixField];
      int nrofBytesType;
      field->position = (int16)(ixData * sizeof(master->userData->val[0]) + OFFSETinTYPE_MemUnit(UserData_DataStructMng_Inspc, val));
      field->bitModifiers = 0;
      field->type_ = null; //not defined yet.
      field->nrofArrayElementsOrBitfield_ = 0; //default: scalar
      if (name[0] == '-' && zname >=2) { //access rights
        char cAccess = name[1];
        if (cAccess >= '0' && cAccess <= '7') {
          field->bitModifiers |= ((cAccess - '0') << kBitAccessLevel_Modifier_FieldJc) & mAccessLevel_Modifier_FieldJc;
        }
        name += 2; zname -= 2;
        cAccess = name[0];  //next char: write
        if (cAccess >= '0' && cAccess <= '7') {
          field->bitModifiers |= ((cAccess - '0') << kBitChangeLevel_Modifier_FieldJc) & mChangeLevel_Modifier_FieldJc;
          name += 1; zname -= 1;
        }
        if (*name == ':') { name += 1; zname -= 1; } //skip over ':', "-27:" admissible.
      }
      while (zname >0 && *name == ' ') { name += 1; zname -= 1; } //skip spaces
      int posPtr = searchChar_emC(name, zname, '*');
      if (posPtr >= 0) {  //access to the content of a pointer.
        if (thiz->portTypes->entries[ixArg].type == 'U') {
          field->bitModifiers |= kHandlePtr_Modifier_reflectJc | kReference_Modifier_reflectJc;
          nrofBytesType = 4;
          if (posPtr > 0) {
            ClassJc* typeClass = (ClassJc*)os_allocMem(sizeof(ClassJc));
            field->type_ = typeClass;
            typeClass->modifiers = mObjectJc_Modifier_reflectJc;  //take runtime type from src.
            int zz = MIN_emC(posPtr, sizeof(typeClass->name));
            strncpy_emC(typeClass->name, name, zz);
            thiz->dataTypeSmlkInput[ixArg] = 'H'; //typed Handle
          }
          else {
            field->type_ = REFLECTION_ObjectJc;
            thiz->dataTypeSmlkInput[ixArg] = 'L'; //An Object
          }
        }
        else { //any other type then uint32
          field->bitModifiers |= kStaticArray_Modifier_reflectJc | kReference_Modifier_reflectJc;
          thiz->dataTypeSmlkInput[ixArg] = 'P'; //Pointer
        }
        name += posPtr + 1;  //without '*'
        zname -= posPtr + 1;
      }
      //
      if (field->type_ == null) {
        //define the type , it is defined for special cases already.
        bool bComplex = thiz->portTypes->entries[ixArg].type >= 'a';
        int cType;
        thiz->dataTypeSmlkInput[ixArg] = thiz->portTypes->entries[ixArg].type;
        switch (thiz->portTypes->entries[ixArg].type) {
        case 'D': nrofBytesType = 8; cType = kREFLECTION_double_ClassJc; break;
        case 'd': nrofBytesType = 8; cType = kREFLECTION_complexdouble_ClassJc; break;
        case 'F': nrofBytesType = 4; cType = kREFLECTION_float_ClassJc; break;
        case 'f': nrofBytesType = 4; cType = kREFLECTION_complexfloat_ClassJc; break;
        case 'I': nrofBytesType = 4; cType = kREFLECTION_int32_ClassJc; break;
        case 'i': nrofBytesType = 4; cType = kREFLECTION_int32_ClassJc; break;
        case 'U': nrofBytesType = 4; cType = kREFLECTION_uint32_ClassJc; break;
        case 'S': nrofBytesType = 2; cType = kREFLECTION_int16_ClassJc; break;
        case 'W': nrofBytesType = 2; cType = kREFLECTION_uint16_ClassJc; break;
        case 'B': nrofBytesType = 1; cType = kREFLECTION_int8_ClassJc; break;
        case 'V': nrofBytesType = 1; cType = kREFLECTION_uint8_ClassJc; break;
        case 'C': nrofBytesType = 1; cType = kREFLECTION_char_ClassJc; break;
        case 'Z': nrofBytesType = 1; cType = kREFLECTION_boolean_ClassJc; break;
          //Bus: type = 0x20
        default: cType = REFLECTION_uint32_ClassJc;
        } //switch
        if (bComplex) { nrofBytesType *= 2; }
        field->type_ = ((struct ClassJc_t const*)cType); //REFLECTION_float;
      }
      if (field->nrofArrayElementsOrBitfield_ == 0) {  //if special determined do not change. 
        int sizeArray = thiz->portTypes->entries[ixArg].sizeArray[0]; //0 possible if scalar. 
        if (sizeArray > 1) {                           //==1: remain 0 for scalar.
          field->nrofArrayElementsOrBitfield_ = sizeArray;
          nrofBytesType *= sizeArray;
          field->bitModifiers |= kStaticArray_Modifier_reflectJc;
        }
      }
      while (zname >0 && *name == ' ') { zname -= 1; name += 1; } //skip spaces
      thiz->nrofbytesInput[ixArg] = nrofBytesType;
      if (*name == '{') {
        thiz->nrofbytesInput[ixArg] = -nrofBytesType;  //negativ means, only set one time after init.
        zname -= 1; name += 1;
        while (zname >0 && *name == ' ') { zname -= 1; name += 1; } //skip spaces
        //if(name[zname-1] == '}'){ zname -=1; }  //{name} semantic initialize 
      }
      //copy only identifier:
      zname = 0;
      char cc;
      while( (cc = name[zname]) >= 'A' && cc <='Z' || cc >= 'a' && cc <= 'z' || cc >= '0' && cc <= '9' || cc == '_') { zname +=1; }
      if(zname > sizeof(field->name)){ zname = sizeof(field->name); }  //shorten a too long name, it is visible as error of access or in reflection.
      strncpy_emC(field->name, name, zname);
      thiz->ixField[ixArg] = ixField;
      ixField += 1;
      ixData += ((nrofBytesType + 3) >> 2); //aligned to 4

    } //zname >0
  }
  master->ixDataLast = ixData;
  return ixField;
}




char const* init_DataStruct_Inspc(DataStruct_Inspc* thiz, DataStruct_Inspc* prevchain
  , struct DefPortTypes_emC_t* portTypes)
  {
  char const* error = null;
  thiz->prevchain = prevchain;
  thiz->portTypes = portTypes;
  if( thiz->userData != null) { //it is processed from master 
    setInitialized_ObjectJc(&thiz->base.object);
  }
  return error;
}





char const* init_DataStructMng_Inspc(DataStructMng_Inspc* thiz, struct DataStruct_Inspc_t* prevchain
  , StringJc dirGenSource_param
  , StringJc nameRefl
  , StringJc n1, StringJc n2, StringJc n3, StringJc n4, StringJc n5, StringJc n6
  , UserHead_DataStructMng_Inspc** data_y
  , struct DefPortTypes_emC_t const* portTypesFromSmlk)
{ 

  thiz->base.DataStruct_Inspc.portTypes = portTypesFromSmlk;

  thiz->base.DataStruct_Inspc.names[0] = n1;   //using for(0..11)
  thiz->base.DataStruct_Inspc.names[1] = n2;   //Note: The n.. params refer a non persistent memory area.
  thiz->base.DataStruct_Inspc.names[2] = n3;   //Therefore this StringJc have to used only in this routine.
  thiz->base.DataStruct_Inspc.names[3] = n4;   //After them this element names[..] are removed.
  thiz->base.DataStruct_Inspc.names[4] = n5;
  thiz->base.DataStruct_Inspc.names[5] = n6;

  //
  int nrofFields = 0;
  int nrofData = 0;
  DataStruct_Inspc* slave = &thiz->base.DataStruct_Inspc;
  slave->prevchain = prevchain;
  bool bDoinit = true;
  do { //check all slaves in chain. If they are not initialized, abort this initialization.
    if(slave->dataTypeSmlkInput !=null) {
      int32 ret = evalSizes_DataStructBase_Inspc(slave);
      nrofFields += (ret & 0xff);
      nrofData += (ret >>16) & 0xffff;
      slave = slave->prevchain;
    }
    else {
      bDoinit = false; //not all slaves are initialized yet.
    }
  } while (bDoinit && slave != null);
  //
  if(bDoinit) {
    if(nrofData < zBaseVal_UserData_DataStructMng_Inspc) { nrofData = zBaseVal_UserData_DataStructMng_Inspc; }
    int userDataBytes = sizeof(UserData_DataStructMng_Inspc) + sizeof(int32) * (nrofData - zBaseVal_UserData_DataStructMng_Inspc);
    thiz->userData = (UserData_DataStructMng_Inspc*) os_allocMem(userDataBytes);
    if(nrofFields < zFieldsInHead_FieldJc_Y){ nrofFields = zFieldsInHead_FieldJc_Y; }
    int fieldBytes = sizeof(FieldJc_Y) + (nrofFields - zFieldsInHead_FieldJc_Y) * sizeof(FieldJc);
    thiz->fields = (FieldJc_Y*) os_allocMem(fieldBytes);
    //
    //fill the local given superclass and class data.
    init_immediate_ObjectArrayJc(&thiz->superclass.head, 1, sizeof(thiz->superclass.clazz), null, 0);
    init_ClassOffset_idxMtblJc(&thiz->superclass.clazz, &reflection_UserHead_DataStructMng_Inspc, kDevlpAccess_CheckPwd_Inspc, 0);
    init_Fields_super_ClassJc(&thiz->clazz, nameRefl, &thiz->fields->head, &thiz->superclass.head);
    int posField = OFFSETinTYPE_MemUnit(UserData_DataStructMng_Inspc, val);
    //int posEnd = posField + sizeof(thiz->userData->val);
    thiz->ixInputStep = portTypesFromSmlk->ixInputStep;
    //
    //fill the fields
    int ixField = 0;
    thiz->ixDataLast = 0;
    slave = &thiz->base.DataStruct_Inspc;
    do {
      if (slave != null) {
        slave->clazz = &thiz->clazz;
        slave->userData = &thiz->userData->val[0];
      }
      ixField = evalNames_DataStructBase_Inspc(slave, thiz, ixField);
      slave = slave->prevchain;
    } while (slave != null);
    thiz->fields->head.length = ixField;  //data fields + reference to thiz

    //register this data in the parent node:
    initReflection_ObjectJc(&thiz->userData->base.object, thiz->userData, userDataBytes, &thiz->clazz, 0);
    thiz->userData->base.super.thiz1 = thiz;
    setInitialized_ObjectJc(&thiz->userData->base.object);  //for the offered data
    setInitialized_ObjectJc(&thiz->base.object);  //for the own data
    if(genSource_DataStructMng_Inspc(thiz, dirGenSource_param) ==null) {
      thiz->ctGenSrc = 1000;
    }
    if(data_y !=null) { *data_y = &thiz->userData->base.super; }
    for (int ix = 0; ix < ARRAYLEN_emC(thiz->base.DataStruct_Inspc.names); ++ix) {
      thiz->base.DataStruct_Inspc.names[ix] = null_StringJc;  //remove arg values, they are not persistent.
    }
  }
  return null;
}





void update_DataStruct_Inspc(DataStruct_Inspc* thiz
  , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
)
{
  int ixField = -1;
  int nrofbytesInput;
  //
  void const* addr[6];
  addr[0] = x1;
  addr[1] = x2;
  addr[2] = x3;
  addr[3] = x4;
  addr[4] = x5;
  addr[5] = x6;
  //
  for (int ix = 0; ix < 6; ++ix) {
    nrofbytesInput = thiz->nrofbytesInput[ix];
    if (nrofbytesInput < 0) {             //negative means:
      nrofbytesInput = -nrofbytesInput;   //handle only 1 time as initial value
      thiz->nrofbytesInput[ix] = 0;       //next step: don't use.
    }
    if (nrofbytesInput >0) {
      int ixInVal = thiz->ixInVal[ix];
      memcpy(&thiz->userData[ixInVal], addr[ix], nrofbytesInput);
    }
  }
}






void update_DataStructMng_Inspc(DataStructMng_Inspc* thiz
     , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
     )
{
  int ixField = -1;
  int nrofbytesInput;
  //
  void const* addr[6];
  addr[0] = x1;
  addr[1] = x2;
  addr[2] = x3;
  addr[3] = x4;
  addr[4] = x5;
  addr[5] = x6;
  //
  for (int ix = 0; ix < 6; ++ix) {
    nrofbytesInput = thiz->base.DataStruct_Inspc.nrofbytesInput[ix];
    if (nrofbytesInput < 0) {             //negative means:
      nrofbytesInput = -nrofbytesInput;   //handle only 1 time as initial value
      thiz->base.DataStruct_Inspc.nrofbytesInput[ix] = 0;       //next step: don't use.
    }
    if (nrofbytesInput >0) {
      int ixInVal = thiz->base.DataStruct_Inspc.ixInVal[ix];
      memcpy(&thiz->userData->val[ixInVal], addr[ix], nrofbytesInput);
    }
  }
  /*
  nrofbytesInput = thiz->nrofbytesInput[0];
  if(nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[0];
    memcpy(&thiz->userData->val[ixInVal], x1, nrofbytesInput);
  }
  //
  nrofbytesInput = thiz->nrofbytesInput[1];
  if (nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[1];
    memcpy(&thiz->userData->val[ixInVal], x2, nrofbytesInput);
  }
  //
  nrofbytesInput = thiz->nrofbytesInput[2];
  if (nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[2];
    memcpy(&thiz->userData->val[ixInVal], x3, nrofbytesInput);
  }
  //
  nrofbytesInput = thiz->nrofbytesInput[3];
  if (nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[3];
    memcpy(&thiz->userData->val[ixInVal], x4, nrofbytesInput);
  }
  //
  nrofbytesInput = thiz->nrofbytesInput[4];
  if (nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[4];
    memcpy(&thiz->userData->val[ixInVal], x5, nrofbytesInput);
  }
  //
  nrofbytesInput = thiz->nrofbytesInput[5];
  if (nrofbytesInput >0) {
    int ixInVal = thiz->ixInVal[5];
    memcpy(&thiz->userData->val[ixInVal], x6, nrofbytesInput);
  }
  */
}





char const* initTinit_DataStruct_Inspc(DataStruct_Inspc* thiz
  , struct DefPortTypes_emC_t* portTypes
  , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
  , DataStruct_Inspc* prevchain
) {
  STACKTRC_ENTRY("initTinit_DataStruct_Inspc");
  char const* error = null;
  thiz->prevchain = prevchain;
  thiz->portTypes = portTypes;
  if(thiz->userData !=null) { //it is processed from master 
    //The init is only invoked if all inputs are known (not 0-handle).
    int ixField = -1;
    int nrofbytesInput;
    //
    void const* addr[6];
    addr[0] = x1;
    addr[1] = x2;
    addr[2] = x3;
    addr[3] = x4;
    addr[4] = x5;
    addr[5] = x6;
    //
    bool bCanInitialize = 1;
    for (int ix = 0; ix < 6; ++ix) {
      nrofbytesInput = thiz->nrofbytesInput[ix];
      if (nrofbytesInput < 0) {             //negative not expectable but possible
        nrofbytesInput = -nrofbytesInput;  
      }
      if (nrofbytesInput >0) {
        int ixInVal = thiz->ixInVal[ix];
        if (thiz->dataTypeSmlkInput[ix] == 'H') { //a typed handle
          uint32 handle = *(uint32*)addr[ix];
          if (handle == 0) { //handle is unknown
            bCanInitialize = 0;  //wait for handle
          }
          else if (handle == (uint32(-1))) { //it is a delivered null-pointer
            thiz->userData[ixInVal] = handle;  //it is ok, offer it forward.
          }
          else if (handle != (uint32)thiz->userData[ixInVal]) { //handle value is changed, do not check twice
            thiz->userData[ixInVal] = handle;
            ObjectJc* inPtr = null;
            error = getPtr_Handle2Ptr(handle, (void**)(&(inPtr)));
            if (error != null) { 
              thiz->errorPort |= 1 << ix; 
              bCanInitialize = 0;  //error in system
            } else {
              error = checkStrict_ObjectJc((ObjectJc*)(inPtr), /*sizeof(UserDataHead_DataStructMng_Inspc_t)*/0, 0, null, null);
              if (error != null) { 
                bCanInitialize = 0;  //error in system
                thiz->errorPort |= 1 << ix;
                THROW_s0(IllegalArgumentException, error, ix,0);
              }
              else {
                FieldJc const* field = &thiz->clazz->attributes->data[thiz->ixField[ix]];
                ClassJc const* clazzfield = getType_FieldJc(field);
                if (!instanceof_s_ObjectJc((ObjectJc*)(inPtr), clazzfield->name)) {
                  bCanInitialize = 0;  //error in system
                  thiz->errorPort |= 1 << ix;
                  THROW_s0(IllegalArgumentException, "faulty type on port: ", ix+1, 0);
                }
              }
            }
          }
        }
        else {
          memcpy(&thiz->userData[ixInVal], addr[ix], nrofbytesInput);
          setInitialized_ObjectJc(&thiz->base.object);
        }
      } //for
    }//for
    if (bCanInitialize) {
      setInitialized_ObjectJc(&thiz->base.object);
    }
  }
  STACKTRC_RETURN error;
}






void genSourceContent_DataStructMng_Inspc(DataStructMng_Inspc* thiz) {
  STACKTRC_ENTRY("genSourceContent_DataStructMng_Inspc");
  OS_HandleFile fwr = os_fopenToWrite(thiz->filegen.absPath, false);
  if (!fwr) { thiz->stateGen = 0xe; }
  else {
    struct { StringBuilderJc b; char _[200];} sb = { INIZ_addSize_StringBuilderJc(sb.b, 200), 0};
    os_fwrite(fwr, "#include <applstdef_emC.h>\n", -999);
    os_fwrite(fwr, "\n\n\n\n\n", -999);
    
    //StringJc structName = zMax_StringJc(thiz->clazz.name, sizeof(thiz->clazz.name));
    char structName[(sizeof(thiz->clazz.name) + 4) & ~3] = { 0 };  //[...] calculated in compiletime, at least 1 char more as field->name
    strncpy_emC(structName, thiz->clazz.name, sizeof(thiz->clazz.name)); //NOTE: type->name may not be 0-terminated. typename is.

    setLength_StringBuilderJc(&sb.b, 0, _thCxt);
    append_z_StringBuilderJc(&sb.b, "typdef struct ", _thCxt);
    append_z_StringBuilderJc(&sb.b, structName, _thCxt);
    append_z_StringBuilderJc(&sb.b, "_t {\n", _thCxt);
    os_fwrite(fwr, chars_StringBuilderJc(&sb.b), length_StringBuilderJc(&sb.b));

    for (int ix = 0; ix < thiz->fields->head.length; ++ix) { //without last field, it is "this$"
      FieldJc const* field = &thiz->fields->data[ix];
      StringJc fieldName = zMax_StringJc(field->name, sizeof(field->name));
      ClassJc const* type = getType_FieldJc(field);
      StringJc typeName = zMax_StringJc(type->name, sizeof(type->name));
      setLength_StringBuilderJc(&sb.b, 0, _thCxt);
      append_z_StringBuilderJc(&sb.b, "\n  ", _thCxt);
      append_s_StringBuilderJc(&sb.b, typeName, _thCxt);
      if (field->bitModifiers & mReference_Modifier_reflectJc) {
        append_z_StringBuilderJc(&sb.b, "*", _thCxt);   //a pointer
      }
      append_z_StringBuilderJc(&sb.b, " ", _thCxt);
      append_s_StringBuilderJc(&sb.b, fieldName, _thCxt);
      if (((field->bitModifiers & mPrimitiv_Modifier_reflectJc) != kBitfield_Modifier_reflectJc)
        && field->nrofArrayElementsOrBitfield_ > 1) {
        append_z_StringBuilderJc(&sb.b, "[", _thCxt);
        append_I_StringBuilderJc(&sb.b, field->nrofArrayElementsOrBitfield_, _thCxt);
        append_z_StringBuilderJc(&sb.b, "]", _thCxt);
      }
      append_z_StringBuilderJc(&sb.b, ";\n", _thCxt);
      os_fwrite(fwr, chars_StringBuilderJc(&sb.b), length_StringBuilderJc(&sb.b));

    }

    setLength_StringBuilderJc(&sb.b, 0, _thCxt);
    append_z_StringBuilderJc(&sb.b, "} ", _thCxt);
    append_z_StringBuilderJc(&sb.b, structName, _thCxt);
    append_z_StringBuilderJc(&sb.b, "_s;\n\n", _thCxt);
    os_fwrite(fwr, chars_StringBuilderJc(&sb.b), length_StringBuilderJc(&sb.b));

    char line[200] = { 0 };
    for (int ixOut = 0; ixOut < thiz->outData.zdata; ++ixOut) {
      setLength_StringBuilderJc(&sb.b, 0, _thCxt);
      Out_DataStruct_Inspc_s* data = thiz->outData.data[ixOut];
      FieldJc const* field = data->field;
      StringJc fieldName = zMax_StringJc(field->name, sizeof(field->name));
      //char fieldName[(sizeof(field->name) +4) & ~3] = { 0 };  //[...] calculated in compiletime, at least 1 char more as field->name
      //strncpy_emC(fieldName, field->name, sizeof(field->name)); //NOTE: type->name may not be 0-terminated. typename is.
      ClassJc const* type = getType_FieldJc(field);
      StringJc typeName = zMax_StringJc(type->name, sizeof(type->name));
      //char typeName[(sizeof(type->name) + 4) & ~3] = { 0 };  //[...] calculated in compiletime, at least 1 char more as type->name
      //strncpy_emC(typeName, type->name, sizeof(type->name)); //NOTE: type->name may not be 0-terminated. typename is.
      int zArray = data->portProps.dimensions == 0 ? 1: data->portProps.sizeArray[0];
      append_z_StringBuilderJc(&sb.b, "inline ", _thCxt);
      if (zArray == 1) { //a scalar
        //Note: The sprintf is not better able to read because assiciation place holder to names.
        //snprintf(line, sizeof(line), "inline %s get_%s_\n", typeName, fieldName);
        //better solution may be C++ StringBuilder with overridden operators!
        append_s_StringBuilderJc(&sb.b, typeName, _thCxt);
        if (field->bitModifiers & mReference_Modifier_reflectJc) {
          append_z_StringBuilderJc(&sb.b, "*", _thCxt);
        }
        append_z_StringBuilderJc(&sb.b, " get_", _thCxt);
        append_s_StringBuilderJc(&sb.b, fieldName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "_", _thCxt);
        append_z_StringBuilderJc(&sb.b, structName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "(", _thCxt);
        append_z_StringBuilderJc(&sb.b, structName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "_s* thiz) { return thiz->", _thCxt);
        append_s_StringBuilderJc(&sb.b, fieldName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "; }\n\n", _thCxt);
      }
      else { //array
        append_z_StringBuilderJc(&sb.b, "void get_", _thCxt);
        append_s_StringBuilderJc(&sb.b, fieldName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "_", _thCxt);
        append_z_StringBuilderJc(&sb.b, structName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "(", _thCxt);
        append_z_StringBuilderJc(&sb.b, structName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "_s* thiz, ", _thCxt);
        append_s_StringBuilderJc(&sb.b, typeName, _thCxt);
        append_z_StringBuilderJc(&sb.b, "* dstarray) { memcpy(dstarray, thiz->", _thCxt);
        append_s_StringBuilderJc(&sb.b, fieldName, _thCxt);
        append_z_StringBuilderJc(&sb.b, ", ", _thCxt);
        append_I_StringBuilderJc(&sb.b, data->zBytes, _thCxt);
        append_z_StringBuilderJc(&sb.b, "); }  //array copy with dst bytes.\n\n", _thCxt);
      }
      os_fwrite(fwr, chars_StringBuilderJc(&sb.b), length_StringBuilderJc(&sb.b));

    }



    thiz->stateGen = 2;
    os_fclose(fwr);
  }
  STACKTRC_RETURN;
}








#ifdef __TEST_DataStructMng_Inspc__

#include <Inspc/Out_DataStruct_Inspc.h>



void check(bool cond, char const* text) {
  if (!cond) {
    printf(text);
  }
}



void test_DataStructMng_Inspc() {
  DataStructMng_Inspc inp = { { { { INIZ_objReflId_ObjectJc(inp, null, 0) } } } };

  StringJc empty = INIZ_StringJc("",0);



  DataStruct_Inspc inp2 = { { INIZ_objReflId_ObjectJc(inp, null, 0) } };
  struct { DefPortTypes_emC head; Entry_DefPortType_emC __[12]; } portTypes_inp2 = { 0 };
  ctor_DefPortTypes_emC(&portTypes_inp2.head, 12);
  //The following information came from Simulink port properties:
  portTypes_inp2.head.ixInputStep = 1;
  portTypes_inp2.head.entries[0].type = 'F';
  portTypes_inp2.head.entries[0].sizeType = 4;
  portTypes_inp2.head.entries[0].dimensions = 1;
  portTypes_inp2.head.entries[0].sizeArray[0] = 1;
  portTypes_inp2.head.entries[1].type = 'F';
  portTypes_inp2.head.entries[1].sizeType = 4;
  portTypes_inp2.head.entries[1].dimensions = 1;
  portTypes_inp2.head.entries[1].sizeArray[0] = 2;

  StringJc n2_1 = INIZ_StringJc("n2_1", 2);
  StringJc n2_2 = INIZ_z_StringJc("n2_2");
  ctor_DataStruct_Inspc(&inp2, n2_1, n2_2, empty, empty, empty, empty);
  init_DataStruct_Inspc(&inp2, null
    , &portTypes_inp2.head);




  UserHead_DataStructMng_Inspc* outInputValues = null;
  struct { DefPortTypes_emC head; Entry_DefPortType_emC __[12]; } portTypesInputValues = {0};
  ctor_DefPortTypes_emC(&portTypesInputValues.head, 12);
  //The following information came from Simulink port properties:
  portTypesInputValues.head.ixInputStep = 1;
  portTypesInputValues.head.entries[0].type = 'F';
  portTypesInputValues.head.entries[0].sizeType = 4;
  portTypesInputValues.head.entries[0].dimensions = 1;
  portTypesInputValues.head.entries[0].sizeArray[0] = 1;
  portTypesInputValues.head.entries[1].type = 'F';
  portTypesInputValues.head.entries[1].sizeType = 4;
  portTypesInputValues.head.entries[1].dimensions = 1;
  portTypesInputValues.head.entries[1].sizeArray[0] = 2;
  portTypesInputValues.head.entries[2].type = 'U';
  portTypesInputValues.head.entries[2].sizeType = 4;
  portTypesInputValues.head.entries[2].dimensions = 1;
  portTypesInputValues.head.entries[2].sizeArray[0] = 1;
  portTypesInputValues.head.entries[3].type = 'U';
  portTypesInputValues.head.entries[3].sizeType = 4;
  portTypesInputValues.head.entries[3].dimensions = 1;
  portTypesInputValues.head.entries[3].sizeArray[0] = 1;

  ctor_DataStructMng_Inspc(&inp);
  StringJc n1 = INIZ_StringJc("n1", 2);
  StringJc n2 = INIZ_z_StringJc("n12");
  StringJc n3 = INIZ_z_StringJc("-10 MeasPrep_ProgrSimpleExmplA* xMeas");
  StringJc n4 = INIZ_z_StringJc("*ptr");
  init_DataStructMng_Inspc(&inp, &inp2, z_StringJc("D:/vishia/smlk/Smlk_ProgrSimple/genSrc")
    , z_StringJc("Type")
    , n1, n2, n3, n4, empty, empty, &outInputValues, &portTypesInputValues.head);





  StringJc d1 = INIZ_StringJc("n1", 2);
  Out_DataStruct_Inspc_s outdata_d1 = { { INIZ_objReflId_ObjectJc(inp, null, 0) } };
  DefPortTypes_emC portTypeOutData_d1 = { 0 };
  //portTypeOutData.entries = 1;
  portTypeOutData_d1.ixInputStep = 0;
  portTypeOutData_d1.entries[0].type = 'F';
  portTypeOutData_d1.entries[0].sizeType = 4;
  portTypeOutData_d1.entries[0].dimensions = 1;
  portTypeOutData_d1.entries[0].sizeArray[0] = 1;
  ctor_Out_DataStruct_Inspc(&outdata_d1.base.object, z_StringJc("F"), 0.001f);
  init_Out_DataStruct_Inspc(&outdata_d1, &portTypeOutData_d1, d1, outInputValues);


  StringJc d2 = INIZ_z_StringJc("n2_2");
  Out_DataStruct_Inspc_s outdata_d2 = { { INIZ_objReflId_ObjectJc(inp, null, 0) } };
  DefPortTypes_emC portTypeOutData_d2 = {0};
  //portTypeOutData.entries = 1;
  portTypeOutData_d2.ixInputStep = 0;
  portTypeOutData_d2.entries[0].type = 'F';
  portTypeOutData_d2.entries[0].sizeType = 4;
  portTypeOutData_d2.entries[0].dimensions = 1;
  portTypeOutData_d2.entries[0].sizeArray[0] = 2;
  ctor_Out_DataStruct_Inspc(&outdata_d2.base.object, z_StringJc("F"), 0.001f);
  init_Out_DataStruct_Inspc(&outdata_d2, &portTypeOutData_d2, d2, outInputValues);

  StringJc d3 = INIZ_z_StringJc("xMeas");
  Out_DataStruct_Inspc_s outdata_d3 = { { INIZ_objReflId_ObjectJc(inp, null, 0) } };
  DefPortTypes_emC portTypeOutData_d3 = { 0 };
  //portTypeOutData.entries = 1;
  portTypeOutData_d3.ixInputStep = 0;
  portTypeOutData_d3.entries[0].type = 'U';
  portTypeOutData_d3.entries[0].sizeType = 4;
  portTypeOutData_d3.entries[0].dimensions = 1;
  portTypeOutData_d3.entries[0].sizeArray[0] = 1;
  ctor_Out_DataStruct_Inspc(&outdata_d3.base.object, z_StringJc("H"), 0.001f);
  init_Out_DataStruct_Inspc(&outdata_d3, &portTypeOutData_d3, d3, outInputValues);

  StringJc d4 = INIZ_z_StringJc("ptr");



  int32 error = 0;
  float testval = 0.25f, val2 = 0;;
  float ytestval = 0;
  for (int step = 0; step < 1100; ++step) {
    testval += 0.25f;
    update_DataStruct_Inspc(&inp2, &val2, &testval, null, null, null, null);
    step_DataStructMng_Inspc(&inp); //, &error);
    step_Out_DataStruct_Inspc(&outdata_d2, &ytestval);
    check(testval == ytestval, "error");
  }


  dtor_DataStructMng_Inspc(&inp);

}


void main() {
  test_DataStructMng_Inspc();
}


#endif //__TEST_DataStructMng_Inspc__