#ifndef __DataStructMng_Inspc_h__
#define __DataStructMng_Inspc_h__
#include <applstdef_emC.h>
#include <emC/Object_emC.h>
#include <emC/DefPortTypes_emC.h>
#include <Jc/ReflectionJc.h>
#include <OSAL/os_file.h>
//#include <emC/String_emC.h>

struct DataStruct_Inspc_t;


/* @ CLASS_C DataStruct_Inspc @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

/**This is the core block for an input block of any values which are accessible via the inspector engine.

*/
typedef struct DataStruct_Inspc_t
{
  /**It is the ObjectJc base necessary for Sfunction. */
  union { ObjectJc object; } base;

  /**Reference to the data of the master FB */
  int32* userData;

  /**Reference to the fields of the master FB */
  ClassJc const* clazz;

  StringJc names[6];

  /**in heap, persistent buffer for names. */
  MemC bufferNames;

  struct DefPortTypes_emC_t const* portTypes;

  struct DataStruct_Inspc_t* prevchain;
  
  /**To check in debug, which signals are connected. */
  char dataTypeSmlkInput[8];  //6, 8 because alignment

  /**one entry for any argument / user input. 0=no variable specified. */
  int16 nrofbytesInput[6];
   
  /**One entry only for used inputs (given name). Rest is 0.*/
  int16 ixInVal[6];

  int16 ixField[6];

  int32 errorPort;


} DataStruct_Inspc;


/**Constructs and completes the instance.
* @simulink ctor
*/
void ctor_DataStruct_Inspc(DataStruct_Inspc* thiz, StringJc n1_param, StringJc n2_param, StringJc n3_param, StringJc n4_param, StringJc n5_param, StringJc n6_param);

/**Constructs and completes the instance.
* @simulink dtor
*/
void dtor_DataStruct_Inspc(DataStruct_Inspc* thiz);



/**Initializes. It stores the given port types.
 * @param prevchain: For concatenation.
 * @param thiz_y  The thiz pointer should firstly offered if init is run the first time. no-thizInit on Object-FB.
 *                Note: this is only convinient if aggregations are not neccessary one another. Here it is ok.
 * @simulink init
 */
char const* initTinit_DataStruct_Inspc(DataStruct_Inspc* thiz
  , struct DefPortTypes_emC_t* portTypes
  , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
  , DataStruct_Inspc* prevchain
);


/**Stores the given values from inputs. The type of inputs are determined by [[init_DataStruct_Inspc(...)]].
 * @simulink Object-FB, no-thizStep.
 */
inline void stepTinit_DataStruct_Inspc(DataStruct_Inspc* thiz) {}  //empty




/**Initializes. It stores the given port types.
 * @param prevchain: For concatenation.
 * @param thiz_y  The thiz pointer should firstly offered if init is run the first time. no-thizInit on Object-FB.
 *                Note: this is only convinient if aggregations are not neccessary one another. Here it is ok.
 * @simulink init.
 */
char const* init_DataStruct_Inspc(DataStruct_Inspc* thiz, DataStruct_Inspc* prevchain
  , struct DefPortTypes_emC_t* portTypes
);



/**Stores the given values from inputs. The type of inputs are determined by [[init_DataStruct_Inspc(...)]].
* @simulink update.
*/
void update_DataStruct_Inspc(DataStruct_Inspc* thiz
  , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
);



/**Stores the given values from inputs. The type of inputs are determined by [[init_DataStruct_Inspc(...)]].
* @simulink Object-FB, no-thizStep.
*/
inline void step_DataStruct_Inspc(DataStruct_Inspc* thiz){} //empty.



/* @ CLASSC DataStructMng_Inspc @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@q*/



//struct DataNode_Inspc_t;

struct Out_DataStruct_Inspc_t;

struct DataStructMng_Inspc_t;

typedef struct UserHead_DataStructMng_Inspc_t
{ /**The ObjectJc base is part of the user Data. */
  union { ObjectJc object; } base;

  struct DataStructMng_Inspc_t* thiz1;

} UserHead_DataStructMng_Inspc;



typedef struct UserData_DataStructMng_Inspc_t
{ /**The ObjectJc base is part of the user Data. */
  union { ObjectJc object; UserHead_DataStructMng_Inspc super; } base;

  #define zBaseVal_UserData_DataStructMng_Inspc 20

  /**Input buffer for at least 12 different value (cluster), maybe a single float, or a float_comlex, or a vector etc.
  * Correct view organized in the reflection.
  */
  int32 val[zBaseVal_UserData_DataStructMng_Inspc];
} UserData_DataStructMng_Inspc;





/**This is the core block for an input block of any values which are accessible via the inspector engine. 

 */
typedef struct DataStructMng_Inspc_t
{ 
  /**It is the ObjectJc base necessary for Sfunction. */
  union { DataStruct_Inspc DataStruct_Inspc; ObjectJc object; } base;

  /**The data which are determined by the parameter of init. */
  UserData_DataStructMng_Inspc* userData;

  int ixDataLast;

  /**Zhler falls irgendwas in config-File nicht stimmt, sollte auf 0 stehen. */
  int32 errorCfg;

  int32 stateGen;

  int32 ixInputStep;

  /**It contains the path from parameter.  */
  FileDescription_OSAL filegen;

  int ctGenSrc;
  
  /**Registered Out_DataStruct_Inspc*/
  struct { 
    int zdata;
    struct Out_DataStruct_Inspc_t* data[300];
  } outData;

#ifndef refl
  //don't generate reflection for this block.

    ClassJc clazz;

    FieldJc_Y* fields;

    //FieldJc _fields[50 - zFieldsInHead_FieldJc_Y]; //TODO 13

    struct {
      ObjectArrayJc head;
      ClassOffset_idxMtblJc clazz;
    } superclass;



  #endif//refl

} DataStructMng_Inspc;


/**Constructs and completes the instance.
* @simulink ctor
*/
void ctor_DataStructMng_Inspc(DataStructMng_Inspc* thiz);

/**Constructs and completes the instance.
* @simulink dtor
*/
void dtor_DataStructMng_Inspc(DataStructMng_Inspc* thiz);

/**Initializes. It stores the given port types.
 * @param data_y: The data pointer in init time for aggregation. 
 * @simulink init
 */
char const* init_DataStructMng_Inspc(DataStructMng_Inspc* thiz, struct DataStruct_Inspc_t* prevChain
  , StringJc dirGenSource_param
  , StringJc nameRefl_param
  , StringJc n1_param, StringJc n2_param, StringJc n3_param, StringJc n4_param, StringJc n5_param, StringJc n6_param
  , UserHead_DataStructMng_Inspc** data_y
  , struct DefPortTypes_emC_t const* portTypes);



/**Stores the given values from inputs. The type of inputs are determined by [[init_DataStructMng_Inspc(...)]].
* @simulink update.
*/
void update_DataStructMng_Inspc(DataStructMng_Inspc* thiz
  , void const* x1, void const* x2, void const* x3, void const* x4, void const* x5, void const* x6
);


void genSourceContent_DataStructMng_Inspc(DataStructMng_Inspc* thiz);



/**Stores the given values from inputs. The type of inputs are determined by [[init_DataStructMng_Inspc(...)]].
* @simulink Object-FB, no-thizInit, no-thizStep.
*/
inline void step_DataStructMng_Inspc(DataStructMng_Inspc* thiz) { //, int32* error_y){
  if (--thiz->ctGenSrc == 0) { //start only if >0 before.
    genSourceContent_DataStructMng_Inspc(thiz);
  }
  else if (thiz->ctGenSrc < 0) {
    thiz->ctGenSrc = -1;  //hold on -1/-2
  }
  //*error_y = thiz->errorPort;
}


/**Registeres an appended Out_DataStruct_Inspc. Note: It is inlined because prevented too much dependencies on linked time for usage. */
inline void registerOutData_DataStructMng_Inspc(DataStructMng_Inspc* thiz, struct Out_DataStruct_Inspc_t* data) {
  int ix = thiz->outData.zdata;
  if (ix < ARRAYLEN_emC(thiz->outData.data) - 1) {
    thiz->outData.zdata = ix + 1;  //maybe use atomic access
    thiz->outData.data[ix] = data;
  }
}





#endif //__DataStructMng_Inspc_h__
