#ifndef __Out_DataStruct_Inspc_h__
#define __Out_DataStruct_Inspc_h__
#include <applstdef_emC.h>
#include <emC/DefPortTypes_emC.h>
#include <Inspc/DataStruct_Inspc.h>
#include <string.h>


struct DefPortTypes_emC_t;

/**Structure of one access to DataStruct. */
typedef struct Out_DataStruct_Inspc_t
{
  union{ ObjectJc object; } base;
  
  /**The output properties for Simulink, used for code generation. */
  Entry_DefPortType_emC portProps;
  
  /**null if ok, elsewhere the error message from init_...(...)*/
  char const* err;
  
  /**Number of bytes to copy to output. */
  int32 zBytes;

  int32 ctRepeatInit;

  /**The ready to use memory address of the data. */
  void* addr;
  
  /**Info for code generation. It is one field from InputValues_Inspc*/
  FieldJc const* field;

} Out_DataStruct_Inspc_s;



/**
* @simulink ctor.
*/
Out_DataStruct_Inspc_s* ctorTinit_Out_DataStruct_Inspc(ObjectJc* othiz);


/**
* @simulink init.
*/
char const* initTinit_Out_DataStruct_Inspc(Out_DataStruct_Inspc_s* thiz, DefPortTypes_emC* defPortTypes, StringJc name_param, struct UserHead_DataStructMng_Inspc_t* inpVal, uint32* handle_y);

/**
* @simulink Object-FB, no-thizInit, no-thizStep.
*/
inline void stepTinit_Out_DataStruct_Inspc(Out_DataStruct_Inspc_s* thiz) {  }





/**
* @simulink ctor.
*/
Out_DataStruct_Inspc_s* ctor_Out_DataStruct_Inspc(ObjectJc* othiz, StringJc type, float Tstep);


/**Routine determines port properties
* @param defPortTypes contains array reference and length of array.
*    It is filled with the given port properties on call. Because of type the information are complemented.
*    With the complemented information the port initialization is done in mdlInizializeSizes
* @simulink defPortTypes.
*/
char const* definePortType_Out_DataStruct_Inspc(DefPortTypes_emC* defPortTypes, EDefPortTypes_emC cause, StringJc type);





/**
* @simulink init.
*/
char const* init_Out_DataStruct_Inspc(Out_DataStruct_Inspc_s* thiz, DefPortTypes_emC* defPortTypes, StringJc name_param, struct UserHead_DataStructMng_Inspc_t* inpVal);

/**
* @simulink Object-FB, no-thizInit, no-thizStep.
*/
inline void step_Out_DataStruct_Inspc(Out_DataStruct_Inspc_s* thiz, void* y_y) { memcpy(y_y, thiz->addr, thiz->zBytes); }



/**
* @simulink Object-FB, no-thizInit, no-thizStep.
*/
inline void set_Out_DataStruct_Inspc(Out_DataStruct_Inspc_s* thiz, void const* x) { memcpy(thiz->addr, x, thiz->zBytes); }







#endif // __Out_DataStruct_Inspc_h__
