#ifndef __Smlk__SfH_Smlk_h__
#define __Smlk__SfH_Smlk_h__
#include <applstdef_emC.h>
#include <emC/DefPortTypes_emC.h>


/**This struct contains data which are necessary to organize generated S-functions with script simulink_Sfn_SfH.jzTc. 
 * That data are not part of the user's algorithm inside the Sfunction.
 * Note: the types used are that types which are defined in incComplSpecific/cc_SmlkSfunc_64bit/compl_adaption.h compatible to C99 types. 
 *       Simulink uses its own type system. But if that values are used in any user algorithm the simulink typesystem is not proper.
 */
typedef struct XXXSfH_Smlk_t {
  
  /**Describes the kind of code generation gotten from GetRTWEnvironmentMode(), rtwenvironmentmode and ssRTWGenIsModelReferenceSimTarget. */
  int32_t isSimulationTarget;

  /**Number of the port which determines the fastest step time. It is evaluated in mdlSetInputPortSampleTime(...) or set initally to the first step input. */
  int32_t ixInputStepfastG;

  /**This have to be the last element. After that space for some more Entry_DefPortTypeJc are allocated. */
  DefPortTypes_emC portInfo;

} XXXSfH_Smlk_s;

#endif //__Smlk__SfH_Smlk_h__
